const char *rprf_test_rcsid = "$Header: /u/spert/src/rprf/RCS/rprf_test.c,v 1.6 1995/09/13 00:12:49 krste Exp $";
/*
    Performs some simple tests of the rprf library.
*/

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <memory.h>

#include "rprf.h"

void
test_parse_args(void)
{
    static const char *test_argv[] = {
        "progname", "-o", "143", "-i", "0x100",
	"123", "ok", "123.125", "4.2e9"
    };

    long l = 0l;
    float f = 0.0f;
    double d = 0.0;
    const char* s = NULL;

    rprf_parse_args(9, test_argv, "isfd", &l, &s, &f, &d);
    printf("\n");

    assert(rprf_n_inner==0x100);
    assert(rprf_n_outer==143);
    assert(l==123);
    assert(strcmp(s, "ok")==0);
    assert(f==123.125f);
    assert(d==4.2e9);
}

void
test_malloc(void)
{
    char *cp = rprf_malloc_vi8(123);
    short *sp = rprf_malloc_vi16(120);
    long *lp = rprf_malloc_vi32(100);
    float *fp = rprf_malloc_vf(10);
    double *dp = rprf_malloc_vd(1023);
}

void
test_rprf_body(void)
{
    char *s1 = rprf_malloc_vi8(123);
    char *s2 = rprf_malloc_vi8(123);

    memset(s1, 'a', 121);
    memset(s2, 'a', 121);
    s1[122] = '0';
    s2[122] = '0';

    RPRF_BODY( {(void) strcmp(s1, s2);}, 121);
    printf("\n");
}

int
main(int argc, const char *argv[])
{
    rprf_parse_args(argc, argv, "");
    test_rprf_body();
    test_malloc();
    test_parse_args();          /* Must do this last as it wipes out args. */

    return 0;
}
